OGRE: Ogre::v1::TextAreaOverlayElement Class Reference

| OGRE 2.2.4 Object-Oriented Graphics Rendering Engine

Classes | Public Types | Public Member Functions | Static Public Member Functions | Public Attributes | List of all members
Ogre::v1::TextAreaOverlayElement Class Reference
Core » Overlays

This class implements an overlay element which contains simple unformatted text. More...

`#include <OgreTextAreaOverlayElement.h>`

Inheritance diagram for Ogre::v1::TextAreaOverlayElement:
[legend]

## Classes
class | CmdAlignment
| Command object for setting the alignment. More...
class | CmdCaption
| Command object for setting the caption. More...
class | CmdCharHeight
| Command object for setting the char height. More...
class | CmdColour
| Command object for setting the constant colour. More...
class | CmdColourBottom
| Command object for setting the bottom colour. More...
class | CmdColourTop
| Command object for setting the top colour. More...
class | CmdFontName
| Command object for setting the caption. More...
class | CmdSpaceWidth
| Command object for setting the width of a space. More...

## Public Types
enum | Alignment { Left, Right, Center }
typedef map< size_t, Vector4 >::type | CustomParameterMap

## Public Member Functions
| TextAreaOverlayElement (const String &name)
| Constructor. More...
virtual | ~TextAreaOverlayElement ()
virtual void | _getClippingRegion (RealRect &clippingRegion)
| Gets the clipping region of the element. More...
virtual Real | _getDerivedLeft (void)
| Gets the 'left' position as derived from own left and that of parents. More...
virtual Real | _getDerivedTop (void)
| Gets the 'top' position as derived from own left and that of parents. More...
Real | _getHeight (void) const
| Gets the height of this element in relation to the screen (where 1.0 = screen height) More...
Real | _getLeft (void) const
| Gets the left of this element in relation to the screen (where 0 = far left, 1.0 = far right) More...
virtual Real | _getRelativeHeight (void)
| Gets the 'height' as derived from own height and metrics mode. More...
virtual Real | _getRelativeWidth (void)
| Gets the 'width' as derived from own width and metrics mode. More...
Real | _getTop (void) const
| Gets the top of this element in relation to the screen (where 0 = far left, 1.0 = far right) More...
Real | _getWidth (void) const
| Gets the width of this element in relation to the screen (where 1.0 = screen width) More...
virtual void | _notifyParent (OverlayContainer *parent, Overlay *overlay)
| Internal method for notifying the GUI element of it's parent and ultimate overlay. More...
virtual void | _notifyViewport ()
| Internal method to notify the element when the viewport of parent overlay has changed. More...
virtual void | _positionsOutOfDate (void)
| Tell the object to recalculate. More...
virtual void | _releaseManualHardwareResources ()
virtual void | _restoreManualHardwareResources ()
void | _setDimensions (Real width, Real height)
| Sets the width and height of this element in relation to the screen (where 1.0 = screen width) More...
void | _setHeight (Real height)
| Sets the height of this element in relation to the screen (where 1.0 = screen width) More...
virtual void | _setHlmsHashes (uint32 hash, uint32 casterHash)
| Manually sets the hlms hashes. Don't call this directly. More...
void | _setLeft (Real left)
| Sets the left of this element in relation to the screen (where 1.0 = screen width) More...
virtual void | _setNullDatablock (void)
| Sets the datablock to a null pointer. More...
void | _setParent (OverlayContainer *parent)
void | _setPosition (Real left, Real top)
| Sets the left and top of this element in relation to the screen (where 1.0 = screen width) More...
void | _setTop (Real top)
| Sets the top of this element in relation to the screen (where 1.0 = screen width) More...
void | _setWidth (Real width)
| Sets the width of this element in relation to the screen (where 1.0 = screen width) More...
void | _update (void)
| Overridden from OverlayElement. More...
virtual void | _updateCustomGpuParameter (const GpuProgramParameters_AutoConstantEntry &constantEntry, GpuProgramParameters *params) const
| Update a custom GpuProgramParameters constant which is derived from information only this Renderable knows. More...
virtual void | _updateFromParent (void)
| Updates this elements transform based on it's parent. More...
virtual void | _updateRenderQueue (RenderQueue *queue, Camera *camera, const Camera *lodCamera)
| Internal method to put the contents onto the render queue. More...
void | addPoseWeight (size_t index, float w)
virtual OverlayElement * | clone (const String &instanceName)
virtual bool | contains (Real x, Real y) const
| Returns true if xy is within the constraints of the component. More...
virtual void | copyFromTemplate (OverlayElement *templateOverlay)
virtual void | copyParametersTo (StringInterface *dest) const
| Method for copying this object's parameters to another object. More...
virtual OverlayElement * | findElementAt (Real x, Real y)
| Returns true if xy is within the constraints of the component. More...
Alignment | getAlignment () const
virtual const DisplayString & | getCaption (void) const
| Gets the caption for this element. More...
virtual bool | getCastsShadows (void) const
| Method which reports whether this renderable would normally cast a shadow. More...
Real | getCharHeight () const
const ColourValue & | getColour (void) const
| Gets the colour of the text. More...
const ColourValue & | getColourBottom (void) const
| Gets the colour of the bottom of the letters. More...
const ColourValue & | getColourTop (void) const
| Gets the colour of the top of the letters. More...
uint8 | getCurrentMaterialLod (void) const
const Vector4 & | getCustomParameter (size_t index) const
| Gets the custom value associated with this Renderable at the given index. More...
const CustomParameterMap & | getCustomParameters (void) const
HlmsDatablock * | getDatablock (void) const
const String & | getFontName () const
Real | getHeight (void) const
| Gets the height of this element in relation to the screen (where 1.0 = screen height) More...
uint32 | getHlmsCasterHash (void) const
uint32 | getHlmsHash (void) const
virtual GuiHorizontalAlignment | getHorizontalAlignment (void) const
| Gets the horizontal alignment for this element. More...
Real | getLeft (void) const
| Gets the left of this element in relation to the screen (where 0 = far left, 1.0 = far right) More...
const LightList & | getLights (void) const
| Gets a list of lights, ordered relative to how close they are to this renderable. More...
const MaterialPtr & | getMaterial (void) const
| See Renderable. More...
virtual const String & | getMaterialName (void) const
| Gets the name of the material this element uses. More...
virtual GuiMetricsMode | getMetricsMode (void) const
| Retrieves the current settings of how the element metrics are interpreted. More...
const String & | getName (void) const
| Gets the name of this overlay. More...
unsigned short | getNumPoses (void) const
virtual unsigned short | getNumWorldTransforms (void) const
| Returns the number of world transform matrices this renderable requires. More...
ParamDictionary * | getParamDictionary (void)
| Retrieves the parameter dictionary for this class. More...
const ParamDictionary * | getParamDictionary (void) const
virtual String | getParameter (const String &name) const
| Generic parameter retrieval method. More...
const ParameterList & | getParameters (void) const
| Retrieves a list of parameters valid for this object. More...
OverlayContainer * | getParent ()
| Returns the parent container. More...
virtual bool | getPolygonModeOverrideable (void) const
| Gets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting. More...
bool | getPoseHalfPrecision () const
bool | getPoseNormals () const
TexBufferPacked * | getPoseTexBuffer () const
float | getPoseWeight (size_t index) const
float * | getPoseWeights () const
void | getRenderOperation (v1::RenderOperation &op, bool casterPass)
| See Renderable. More...
uint8 | getRenderQueueSubGroup (void) const
const OverlayElement * | getSourceTemplate () const
| Returns the SourceTemplate for this element. More...
Real | getSpaceWidth () const
Real | getTop (void) const
| Gets the top of this element in relation to the screen (where 0 = top, 1.0 = bottom) More...
virtual const String & | getTypeName (void) const
| See OverlayElement. More...
bool | getUseIdentityProjection (void) const
| Returns whether or not to use an 'identity' projection. More...
bool | getUseIdentityView (void) const
| Returns whether or not to use an 'identity' view. More...
virtual bool | getUseIdentityViewProjMatrixIsDynamic (void) const
| Returns whether the Hlms implementation should evaluate getUseIdentityProjection per object at runtime, or if it can assume the Renderable will remain with the same setting until the datablock is flushed (performance optimization) More...
virtual bool | getUseIdentityWorldMatrix (void) const
| Returns whether the world matrix is an identity matrix. More...
virtual OGRE_DEPRECATED const Any & | getUserAny (void) const
UserObjectBindings & | getUserObjectBindings ()
| Return an instance of user objects binding associated with this class. More...
const UserObjectBindings & | getUserObjectBindings () const
| Return an instance of user objects binding associated with this class. More...
const VertexArrayObjectArray & | getVaos (VertexPass vertexPass) const
virtual GuiVerticalAlignment | getVerticalAlignment (void) const
| Gets the vertical alignment for this element. More...
Real | getWidth (void) const
| Gets the width of this element in relation to the screen (where 1.0 = screen width) More...
void | getWorldTransforms (Matrix4 *xform) const
| See Renderable. More...
bool | hasCustomParameter (size_t index) const
| Checks whether a custom value is associated with this Renderable at the given index. More...
bool | hasSkeletonAnimation (void) const
virtual void | hide (void)
| Hides this element if it was visible. More...
virtual void | initialise (void)
| Initialise gui element. More...
virtual bool | isCloneable () const
virtual bool | isContainer () const
| returns false as this class is not a container type More...
bool | isEnabled () const
virtual bool | isKeyEnabled () const
bool | isVisible (void) const
| Returns whether or not the element is visible. More...
void | operator delete (void *ptr)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete (void *ptr, void *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
void * | operator new (size_t sz)
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info More...
void * | operator new (size_t sz, void *ptr)
| placement operator new More...
void * | operator new[] (size_t sz)
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info More...
virtual void | postRender (SceneManager *sm, RenderSystem *rsys)
| Called immediately after the Renderable has been rendered. More...
virtual bool | preRender (SceneManager *sm, RenderSystem *rsys)
| Called just prior to the Renderable being rendered. More...
void | removeCustomParameter (size_t index)
| Removes a custom value which is associated with this Renderable at the given index. More...
void | setAlignment (Alignment a)
virtual void | setCaption (const DisplayString &text)
| Sets the caption on elements that support it. More...
void | setCharHeight (Real height)
virtual void | setCloneable (bool c)
void | setColour (const ColourValue &col)
| Sets the colour of the text. More...
void | setColourBottom (const ColourValue &col)
| Sets the colour of the bottom of the letters. More...
void | setColourTop (const ColourValue &col)
| Sets the colour of the top of the letters. More...
void | setCustomParameter (size_t index, const Vector4 &value)
| Sets a custom parameter for this Renderable, which may be used to drive calculations for this specific Renderable, like GPU program parameters. More...
virtual void | setDatablock (HlmsDatablock *datablock)
| Assigns a datablock (i.e. HLMS Material) to this renderable. More...
void | setDatablock (IdString datablockName)
| Assigns a datablock (i.e. More...
void | setDatablockOrMaterialName (String materialName, String groupName)
| First tries to see if an HLMS datablock exist with the given name, if not, tries to search among low level materials. More...
void | setDimensions (Real width, Real height)
| Sets the dimensions of this element in relation to the screen (1.0 = screen width/height). More...
virtual void | setEnabled (bool b)
void | setFontName (const String &font)
void | setHeight (Real height)
| Sets the height of this element in relation to the screen (where 1.0 = screen height) More...
virtual void | setHorizontalAlignment (GuiHorizontalAlignment gha)
| Sets the horizontal origin for this element. More...
void | setLeft (Real left)
| Sets the left of this element in relation to the screen (where 0 = far left, 1.0 = far right) More...
virtual void | setMaterial (const MaterialPtr &material)
| Sets the given material. Overrides HLMS materials. More...
void | setMaterialName (const String &matName)
| Overridden from OverlayElement. More...
void | setMaterialName (const String &name, const String &groupName)
| Sets the name of the Material to be used. Prefer using HLMS @See setHlms. More...
void | setMetricsMode (GuiMetricsMode gmm)
| Overridden from OverlayElement. More...
virtual bool | setParameter (const String &name, const String &value)
| Generic parameter setting method. More...
virtual void | setParameterList (const NameValuePairList &paramList)
| Generic multiple parameter setting method. More...
virtual void | setPolygonModeOverrideable (bool override)
| Sets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting. More...
void | setPoseWeight (size_t index, float w)
void | setPosition (Real left, Real top)
| Sets the position of the top-left corner of the element, relative to the screen size (1.0 = screen width / height) More...
void | setRenderQueueSubGroup (uint8 subGroup)
| Sets the render queue sub group. More...
void | setSpaceWidth (Real width)
void | setTop (Real Top)
| Sets the top of this element in relation to the screen (where 0 = top, 1.0 = bottom) More...
void | setUseIdentityProjection (bool useIdentityProjection)
| Sets whether or not to use an 'identity' projection. More...
void | setUseIdentityView (bool useIdentityView)
| Sets whether or not to use an 'identity' view. More...
virtual OGRE_DEPRECATED void | setUserAny (const Any &anything)
virtual void | setVerticalAlignment (GuiVerticalAlignment gva)
| Sets the vertical origin for this element. More...
void | setWidth (Real width)
| Sets the width of this element in relation to the screen (where 1.0 = screen width) More...
virtual void | show (void)
| Shows this element if it was hidden. More...

## Static Public Member Functions
static void | cleanupDictionary ()
| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g. More...

## Public Attributes
uint8 | mCustomParameter
| Only valid when using low level materials. More...
uint32 | mHlmsGlobalIndex
| Index in the vector holding this Rendrable reference in the HLMS datablock. More...

## Detailed Description

This class implements an overlay element which contains simple unformatted text.

## Member Typedef Documentation

## ◆ CustomParameterMap

typedef map<size_t, Vector4>::type Ogre::Renderable::CustomParameterMap
| inherited

## Member Enumeration Documentation

## ◆ Alignment

enum Ogre::v1::TextAreaOverlayElement::Alignment

Enumerator
Left |
Right |
Center |

## Constructor & Destructor Documentation

## ◆ TextAreaOverlayElement()

Ogre::v1::TextAreaOverlayElement::TextAreaOverlayElement | ( | const String & | name | ) |

Constructor.

## ◆ ~TextAreaOverlayElement()

virtual Ogre::v1::TextAreaOverlayElement::~TextAreaOverlayElement | ( |  | ) |
| virtual

## Member Function Documentation

## ◆ _getClippingRegion()

virtual void Ogre::v1::OverlayElement::_getClippingRegion | ( | RealRect & | clippingRegion | ) |
| virtualinherited

Gets the clipping region of the element.

## ◆ _getDerivedLeft()

virtual Real Ogre::v1::OverlayElement::_getDerivedLeft | ( | void |  | ) |
| virtualinherited

Gets the 'left' position as derived from own left and that of parents.

## ◆ _getDerivedTop()

virtual Real Ogre::v1::OverlayElement::_getDerivedTop | ( | void |  | ) |
| virtualinherited

Gets the 'top' position as derived from own left and that of parents.

## ◆ _getHeight()

Real Ogre::v1::OverlayElement::_getHeight | ( | void |  | ) | const
| inlineinherited

Gets the height of this element in relation to the screen (where 1.0 = screen height)

## ◆ _getLeft()

Real Ogre::v1::OverlayElement::_getLeft | ( | void |  | ) | const
| inlineinherited

Gets the left of this element in relation to the screen (where 0 = far left, 1.0 = far right)

## ◆ _getRelativeHeight()

virtual Real Ogre::v1::OverlayElement::_getRelativeHeight | ( | void |  | ) |
| virtualinherited

Gets the 'height' as derived from own height and metrics mode.

## ◆ _getRelativeWidth()

virtual Real Ogre::v1::OverlayElement::_getRelativeWidth | ( | void |  | ) |
| virtualinherited

Gets the 'width' as derived from own width and metrics mode.

## ◆ _getTop()

Real Ogre::v1::OverlayElement::_getTop | ( | void |  | ) | const
| inlineinherited

Gets the top of this element in relation to the screen (where 0 = far left, 1.0 = far right)

## ◆ _getWidth()

Real Ogre::v1::OverlayElement::_getWidth | ( | void |  | ) | const
| inlineinherited

Gets the width of this element in relation to the screen (where 1.0 = screen width)

## ◆ _notifyParent()

virtual void Ogre::v1::OverlayElement::_notifyParent | ( | OverlayContainer * | parent,
|  | Overlay * | overlay
| ) |  |
| virtualinherited

Internal method for notifying the GUI element of it's parent and ultimate overlay.

Reimplemented in Ogre::v1::OverlayContainer.

## ◆ _notifyViewport()

virtual void Ogre::v1::OverlayElement::_notifyViewport | ( |  | ) |
| virtualinherited

Internal method to notify the element when the viewport of parent overlay has changed.

Reimplemented in Ogre::v1::OverlayContainer.

## ◆ _positionsOutOfDate()

virtual void Ogre::v1::OverlayElement::_positionsOutOfDate | ( | void |  | ) |
| virtualinherited

Tell the object to recalculate.

Reimplemented in Ogre::v1::OverlayContainer.

## ◆ _releaseManualHardwareResources()

virtual void Ogre::v1::TextAreaOverlayElement::_releaseManualHardwareResources | ( |  | ) |
| virtual

Reimplemented from Ogre::v1::OverlayElement.

## ◆ _restoreManualHardwareResources()

virtual void Ogre::v1::TextAreaOverlayElement::_restoreManualHardwareResources | ( |  | ) |
| virtual

Reimplemented from Ogre::v1::OverlayElement.

## ◆ _setDimensions()

void Ogre::v1::OverlayElement::_setDimensions | ( | Real | width,
|  | Real | height
| ) |  |
| inherited

Sets the width and height of this element in relation to the screen (where 1.0 = screen width)

## ◆ _setHeight()

void Ogre::v1::OverlayElement::_setHeight | ( | Real | height | ) |
| inherited

Sets the height of this element in relation to the screen (where 1.0 = screen width)

## ◆ _setHlmsHashes()

virtual void Ogre::Renderable::_setHlmsHashes | ( | uint32 | hash,
|  | uint32 | casterHash
| ) |  |
| virtualinherited

Manually sets the hlms hashes. Don't call this directly.

Reimplemented in Ogre::SubItem.

## ◆ _setLeft()

void Ogre::v1::OverlayElement::_setLeft | ( | Real | left | ) |
| inherited

Sets the left of this element in relation to the screen (where 1.0 = screen width)

## ◆ _setNullDatablock()

virtual void Ogre::Renderable::_setNullDatablock | ( | void |  | ) |
| virtualinherited

Sets the datablock to a null pointer.

Use case: If you will be destroying an HlmsDatablock and all Renderables associated by it; it makes no sense to change the Renderable's datablock to a default one, only to be destroyed immediately after (you pay an unnecessary performance price).

Remarks
  Do not attempt to render a Renderable whose datablock has been set to null. It will crash. You can call setDatablock afterwards though. Use at your own risk, hence the _underscore. See http://ogre3d.org/forums/viewtopic.php?f=25&t=91791&p=534476#p534476

Reimplemented in Ogre::v1::SubEntity, and Ogre::v1::BillboardSet.

## ◆ _setParent()

void Ogre::v1::OverlayElement::_setParent | ( | OverlayContainer * | parent | ) |
| inlineinherited

## ◆ _setPosition()

void Ogre::v1::OverlayElement::_setPosition | ( | Real | left,
|  | Real | top
| ) |  |
| inherited

Sets the left and top of this element in relation to the screen (where 1.0 = screen width)

## ◆ _setTop()

void Ogre::v1::OverlayElement::_setTop | ( | Real | top | ) |
| inherited

Sets the top of this element in relation to the screen (where 1.0 = screen width)

## ◆ _setWidth()

void Ogre::v1::OverlayElement::_setWidth | ( | Real | width | ) |
| inherited

Sets the width of this element in relation to the screen (where 1.0 = screen width)

## ◆ _update()

void Ogre::v1::TextAreaOverlayElement::_update | ( | void |  | ) |
| virtual

Overridden from OverlayElement.

Reimplemented from Ogre::v1::OverlayElement.

## ◆ _updateCustomGpuParameter()

virtual void Ogre::Renderable::_updateCustomGpuParameter | ( | const GpuProgramParameters_AutoConstantEntry & | constantEntry,
|  | GpuProgramParameters * | params
| ) |  | const
| virtualinherited

Update a custom GpuProgramParameters constant which is derived from information only this Renderable knows.

Remarks
  This method allows a Renderable to map in a custom GPU program parameter based on it's own data. This is represented by a GPU auto parameter of ACT_CUSTOM, and to allow there to be more than one of these per Renderable, the 'data' field on the auto parameter will identify which parameter is being updated. The implementation of this method must identify the parameter being updated, and call a 'setConstant' method on the passed in GpuProgramParameters object, using the details provided in the incoming auto constant setting to identify the index at which to set the parameter.

  You do not need to override this method if you're using the standard sets of data associated with the Renderable as provided by setCustomParameter and getCustomParameter. By default, the implementation will map from the value indexed by the 'constantEntry.data' parameter to a value previously set by setCustomParameter. But custom Renderables are free to override this if they want, in any case.

Parameters

  constantEntry | The auto constant entry referring to the parameter being updated
  params | The parameters object which this method should call to set the updated parameters.

Reimplemented in Ogre::v1::SubEntity.

## ◆ _updateFromParent()

virtual void Ogre::v1::OverlayElement::_updateFromParent | ( | void |  | ) |
| virtualinherited

Updates this elements transform based on it's parent.

## ◆ _updateRenderQueue()

virtual void Ogre::v1::OverlayElement::_updateRenderQueue | ( | RenderQueue * | queue,
|  | Camera * | camera,
|  | const Camera * | lodCamera
| ) |  |
| virtualinherited

Internal method to put the contents onto the render queue.

Reimplemented in Ogre::v1::PanelOverlayElement, Ogre::v1::OverlayContainer, and Ogre::v1::BorderPanelOverlayElement.

## ◆ addPoseWeight()

void Ogre::Renderable::addPoseWeight | ( | size_t | index,
|  | float | w
| ) |  |
| inherited

## ◆ cleanupDictionary()

static void Ogre::StringInterface::cleanupDictionary | ( |  | ) |
| staticinherited

Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.

MaterialManager) initializes.

## ◆ clone()

virtual OverlayElement* Ogre::v1::OverlayElement::clone | ( | const String & | instanceName | ) |
| virtualinherited

Reimplemented in Ogre::v1::OverlayContainer.

## ◆ contains()

virtual bool Ogre::v1::OverlayElement::contains | ( | Real | x,
|  | Real | y
| ) |  | const
| virtualinherited

Returns true if xy is within the constraints of the component.

## ◆ copyFromTemplate()

virtual void Ogre::v1::OverlayElement::copyFromTemplate | ( | OverlayElement * | templateOverlay | ) |
| virtualinherited

Reimplemented in Ogre::v1::OverlayContainer.

## ◆ copyParametersTo()

virtual void Ogre::StringInterface::copyParametersTo | ( | StringInterface * | dest | ) | const
| inlinevirtualinherited

Method for copying this object's parameters to another object.

Remarks
  This method takes the values of all the object's parameters and tries to set the same values on the destination object. This provides a completely type independent way to copy parameters to other objects. Note that because of the String manipulation involved, this should not be regarded as an efficient process and should be saved for times outside of the rendering loop.

  Any unrecognised parameters will be ignored as with setParameter method.

Parameters

  dest | Pointer to object to have it's parameters set the same as this object.

References Ogre::StringInterface::setParameter().

## ◆ findElementAt()

virtual OverlayElement* Ogre::v1::OverlayElement::findElementAt | ( | Real | x,
|  | Real | y
| ) |  |
| virtualinherited

Returns true if xy is within the constraints of the component.

Reimplemented in Ogre::v1::OverlayContainer.

## ◆ getAlignment()

Alignment Ogre::v1::TextAreaOverlayElement::getAlignment | ( |  | ) | const
| inline

## ◆ getCaption()

virtual const DisplayString& Ogre::v1::OverlayElement::getCaption | ( | void |  | ) | const
| virtualinherited

Gets the caption for this element.

## ◆ getCastsShadows()

virtual bool Ogre::Renderable::getCastsShadows | ( | void |  | ) | const
| inlinevirtualinherited

Method which reports whether this renderable would normally cast a shadow.

Remarks
  Subclasses should override this if they could have been used to generate a shadow.

Reimplemented in Ogre::ManualObject::ManualObjectSection, Ogre::WireAabb, Ogre::SubItem, Ogre::v1::SubEntity, Ogre::v1::StaticGeometry::GeometryBucket, Ogre::Rectangle2D, Ogre::VoxelVisualizer, and Ogre::IfdProbeVisualizer.

## ◆ getCharHeight()

Real Ogre::v1::TextAreaOverlayElement::getCharHeight | ( |  | ) | const

## ◆ getColour()

const ColourValue& Ogre::v1::TextAreaOverlayElement::getColour | ( | void |  | ) | const
| virtual

Gets the colour of the text.

Reimplemented from Ogre::v1::OverlayElement.

## ◆ getColourBottom()

const ColourValue& Ogre::v1::TextAreaOverlayElement::getColourBottom | ( | void |  | ) | const

Gets the colour of the bottom of the letters.

## ◆ getColourTop()

const ColourValue& Ogre::v1::TextAreaOverlayElement::getColourTop | ( | void |  | ) | const

Gets the colour of the top of the letters.

## ◆ getCurrentMaterialLod()

uint8 Ogre::Renderable::getCurrentMaterialLod | ( | void |  | ) | const
| inlineinherited

## ◆ getCustomParameter()

const Vector4& Ogre::Renderable::getCustomParameter | ( | size_t | index | ) | const
| inlineinherited

Gets the custom value associated with this Renderable at the given index.

Parameters

  index | Index of the parameter to retrieve.

See also
  setCustomParameter for full details.

References Ogre::Exception::ERR_ITEM_NOT_FOUND, and OGRE_EXCEPT.

## ◆ getCustomParameters()

const CustomParameterMap& Ogre::Renderable::getCustomParameters | ( | void |  | ) | const
| inlineinherited

## ◆ getDatablock()

HlmsDatablock* Ogre::Renderable::getDatablock | ( | void |  | ) | const
| inlineinherited

## ◆ getFontName()

const String& Ogre::v1::TextAreaOverlayElement::getFontName | ( |  | ) | const

## ◆ getHeight()

Real Ogre::v1::OverlayElement::getHeight | ( | void |  | ) | const
| inherited

Gets the height of this element in relation to the screen (where 1.0 = screen height)

## ◆ getHlmsCasterHash()

uint32 Ogre::Renderable::getHlmsCasterHash | ( | void |  | ) | const
| inlineinherited

## ◆ getHlmsHash()

uint32 Ogre::Renderable::getHlmsHash | ( | void |  | ) | const
| inlineinherited

## ◆ getHorizontalAlignment()

virtual GuiHorizontalAlignment Ogre::v1::OverlayElement::getHorizontalAlignment | ( | void |  | ) | const
| virtualinherited

Gets the horizontal alignment for this element.

## ◆ getLeft()

Real Ogre::v1::OverlayElement::getLeft | ( | void |  | ) | const
| inherited

Gets the left of this element in relation to the screen (where 0 = far left, 1.0 = far right)

## ◆ getLights()

const LightList& Ogre::v1::OverlayElement::getLights | ( | void |  | ) | const
| inlinevirtualinherited

Gets a list of lights, ordered relative to how close they are to this renderable.

Remarks
  Directional lights, which have no position, will always be first on this list.

Implements Ogre::Renderable.

## ◆ getMaterial()

const MaterialPtr& Ogre::v1::TextAreaOverlayElement::getMaterial | ( | void |  | ) | const

See Renderable.

## ◆ getMaterialName()

virtual const String& Ogre::v1::OverlayElement::getMaterialName | ( | void |  | ) | const
| virtualinherited

Gets the name of the material this element uses.

## ◆ getMetricsMode()

virtual GuiMetricsMode Ogre::v1::OverlayElement::getMetricsMode | ( | void |  | ) | const
| virtualinherited

Retrieves the current settings of how the element metrics are interpreted.

## ◆ getName()

const String& Ogre::v1::OverlayElement::getName | ( | void |  | ) | const
| inherited

Gets the name of this overlay.

Referenced by Ogre::v1::OverlayContainer::_removeChild().

## ◆ getNumPoses()

unsigned short Ogre::Renderable::getNumPoses | ( | void |  | ) | const
| inherited

## ◆ getNumWorldTransforms()

virtual unsigned short Ogre::Renderable::getNumWorldTransforms | ( | void |  | ) | const
| inlinevirtualinherited

Returns the number of world transform matrices this renderable requires.

Remarks
  When a renderable uses vertex blending, it uses multiple world matrices instead of a single one. Each vertex sent to the pipeline can reference one or more matrices in this list with given weights. If a renderable does not use vertex blending this method returns 1, which is the default for simplicity.

Reimplemented in Ogre::v1::SubEntity, and Ogre::v1::BorderRenderable.

## ◆ getParamDictionary() [1/2]

ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) |
| inlineinherited

Retrieves the parameter dictionary for this class.

Remarks
  Only valid to call this after createParamDictionary.

Returns
  Pointer to ParamDictionary shared by all instances of this class which you can add parameters to, retrieve parameters etc.

## ◆ getParamDictionary() [2/2]

const ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) | const
| inlineinherited

## ◆ getParameter()

virtual String Ogre::StringInterface::getParameter | ( | const String & | name | ) | const
| inlinevirtualinherited

Generic parameter retrieval method.

Remarks
  Call this method with the name of a parameter to retrieve a string-format value of the parameter in question. If in doubt, check the parameter definition in the list returned from getParameters for the type of this parameter. If you like you can use StringConverter to convert this string back into a native type.

Parameters

  name | The name of the parameter to get

Returns
  String value of parameter, blank if not found

References Ogre::ParamCommand::doGet().

## ◆ getParameters()

const ParameterList& Ogre::StringInterface::getParameters | ( | void |  | ) | const
| inherited

Retrieves a list of parameters valid for this object.

Returns
  A reference to a static list of ParameterDef objects.

## ◆ getParent()

OverlayContainer* Ogre::v1::OverlayElement::getParent | ( |  | ) |
| inherited

Returns the parent container.

## ◆ getPolygonModeOverrideable()

virtual bool Ogre::Renderable::getPolygonModeOverrideable | ( | void |  | ) | const
| inlinevirtualinherited

Gets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.

Reimplemented in Ogre::v1::BorderRenderable.

Referenced by Ogre::v1::BorderRenderable::getPolygonModeOverrideable().

## ◆ getPoseHalfPrecision()

bool Ogre::Renderable::getPoseHalfPrecision | ( |  | ) | const
| inherited

## ◆ getPoseNormals()

bool Ogre::Renderable::getPoseNormals | ( |  | ) | const
| inherited

## ◆ getPoseTexBuffer()

TexBufferPacked* Ogre::Renderable::getPoseTexBuffer | ( |  | ) | const
| inherited

## ◆ getPoseWeight()

float Ogre::Renderable::getPoseWeight | ( | size_t | index | ) | const
| inherited

## ◆ getPoseWeights()

float* Ogre::Renderable::getPoseWeights | ( |  | ) | const
| inherited

## ◆ getRenderOperation()

void Ogre::v1::TextAreaOverlayElement::getRenderOperation | ( | v1::RenderOperation & | op,
|  | bool | casterPass
| ) |  |
| virtual

See Renderable.

Implements Ogre::Renderable.

## ◆ getRenderQueueSubGroup()

uint8 Ogre::Renderable::getRenderQueueSubGroup | ( | void |  | ) | const
| inlineinherited

## ◆ getSourceTemplate()

const OverlayElement* Ogre::v1::OverlayElement::getSourceTemplate | ( |  | ) | const
| inlineinherited

Returns the SourceTemplate for this element.

## ◆ getSpaceWidth()

Real Ogre::v1::TextAreaOverlayElement::getSpaceWidth | ( |  | ) | const

## ◆ getTop()

Real Ogre::v1::OverlayElement::getTop | ( | void |  | ) | const
| inherited

Gets the top of this element in relation to the screen (where 0 = top, 1.0 = bottom)

## ◆ getTypeName()

virtual const String& Ogre::v1::TextAreaOverlayElement::getTypeName | ( | void |  | ) | const
| virtual

See OverlayElement.

Implements Ogre::v1::OverlayElement.

## ◆ getUseIdentityProjection()

bool Ogre::Renderable::getUseIdentityProjection | ( | void |  | ) | const
| inlineinherited

Returns whether or not to use an 'identity' projection.

Remarks
  Usually Renderable objects will use a projection matrix as determined by the active camera. However, if they want they can cancel this out and use an identity projection, which effectively projects in 2D using a {-1, 1} view space. Useful for overlay rendering. Normal renderables need not change this.

See also
  Renderable::setUseIdentityProjection

## ◆ getUseIdentityView()

bool Ogre::Renderable::getUseIdentityView | ( | void |  | ) | const
| inlineinherited

Returns whether or not to use an 'identity' view.

Remarks
  Usually Renderable objects will use a view matrix as determined by the active camera. However, if they want they can cancel this out and use an identity matrix, which means all geometry is assumed to be relative to camera space already. Useful for overlay rendering. Normal renderables need not change this.

See also
  Renderable::setUseIdentityView

## ◆ getUseIdentityViewProjMatrixIsDynamic()

virtual bool Ogre::Renderable::getUseIdentityViewProjMatrixIsDynamic | ( | void |  | ) | const
| inlinevirtualinherited

Returns whether the Hlms implementation should evaluate getUseIdentityProjection per object at runtime, or if it can assume the Renderable will remain with the same setting until the datablock is flushed (performance optimization)

Remarks
  Hlms implementations may ignore this setting (e.g. assume always true or always false) or even not support identity matrix overrides at all. For example currently Unlit supports them all, but will assume this returns always true if getUseIdentityWorldMatrix returns false.

## ◆ getUseIdentityWorldMatrix()

virtual bool Ogre::Renderable::getUseIdentityWorldMatrix | ( | void |  | ) | const
| inlinevirtualinherited

Returns whether the world matrix is an identity matrix.

Remarks
  It is up to the Hlms implementation whether to honour this request. Take in mind changes of this value at runtime may not be seen until the datablock is flushed. It is implemented as a virtual call because this functionality isn't required very often (hence we save per-Renderable space for those that don't use it) and this function will be called at creation time to use a different shader; not during rendering time per Renderable.

Reimplemented in Ogre::v1::BillboardSet.

## ◆ getUserAny()

virtual OGRE_DEPRECATED const Any& Ogre::Renderable::getUserAny | ( | void |  | ) | const
| inlinevirtualinherited

Deprecated:
  use UserObjectBindings::getUserAny via getUserObjectBindings() instead. Retrieves the custom user value associated with this object.

## ◆ getUserObjectBindings() [1/2]

UserObjectBindings& Ogre::Renderable::getUserObjectBindings | ( |  | ) |
| inlineinherited

Return an instance of user objects binding associated with this class.

You can use it to associate one or more custom objects with this class instance.

See also
  UserObjectBindings::setUserAny.

## ◆ getUserObjectBindings() [2/2]

const UserObjectBindings& Ogre::Renderable::getUserObjectBindings | ( |  | ) | const
| inlineinherited

Return an instance of user objects binding associated with this class.

You can use it to associate one or more custom objects with this class instance.

See also
  UserObjectBindings::setUserAny.

## ◆ getVaos()

const VertexArrayObjectArray& Ogre::Renderable::getVaos | ( | VertexPass | vertexPass | ) | const
| inlineinherited

## ◆ getVerticalAlignment()

virtual GuiVerticalAlignment Ogre::v1::OverlayElement::getVerticalAlignment | ( | void |  | ) | const
| virtualinherited

Gets the vertical alignment for this element.

## ◆ getWidth()

Real Ogre::v1::OverlayElement::getWidth | ( | void |  | ) | const
| inherited

Gets the width of this element in relation to the screen (where 1.0 = screen width)

## ◆ getWorldTransforms()

void Ogre::v1::OverlayElement::getWorldTransforms | ( | Matrix4 * | xform | ) | const
| virtualinherited

See Renderable.

Implements Ogre::Renderable.

Referenced by Ogre::v1::BorderRenderable::getWorldTransforms().

## ◆ hasCustomParameter()

bool Ogre::Renderable::hasCustomParameter | ( | size_t | index | ) | const
| inlineinherited

Checks whether a custom value is associated with this Renderable at the given index.

Parameters

  index | Index of the parameter to check for existence.

See also
  setCustomParameter for full details.

## ◆ hasSkeletonAnimation()

bool Ogre::Renderable::hasSkeletonAnimation | ( | void |  | ) | const
| inlineinherited

## ◆ hide()

virtual void Ogre::v1::OverlayElement::hide | ( | void |  | ) |
| virtualinherited

Hides this element if it was visible.

## ◆ initialise()

virtual void Ogre::v1::TextAreaOverlayElement::initialise | ( | void |  | ) |
| virtual

Initialise gui element.

Implements Ogre::v1::OverlayElement.

## ◆ isCloneable()

virtual bool Ogre::v1::OverlayElement::isCloneable | ( |  | ) | const
| inlinevirtualinherited

## ◆ isContainer()

virtual bool Ogre::v1::OverlayElement::isContainer | ( |  | ) | const
| inlinevirtualinherited

returns false as this class is not a container type

Reimplemented in Ogre::v1::OverlayContainer.

## ◆ isEnabled()

bool Ogre::v1::OverlayElement::isEnabled | ( |  | ) | const
| inherited

## ◆ isKeyEnabled()

virtual bool Ogre::v1::OverlayElement::isKeyEnabled | ( |  | ) | const
| inlinevirtualinherited

## ◆ isVisible()

bool Ogre::v1::OverlayElement::isVisible | ( | void |  | ) | const
| inherited

Returns whether or not the element is visible.

## ◆ operator delete() [1/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete() [2/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator delete() [3/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |
| ) |  |
| inlineinherited

## ◆ operator delete[]() [1/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete[]() [2/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator new() [1/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new() [2/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

operator new, with debug line info

## ◆ operator new() [3/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr
| ) |  |
| inlineinherited

placement operator new

## ◆ operator new[]() [1/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new[]() [2/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

array operator new, with debug line info

## ◆ postRender()

virtual void Ogre::Renderable::postRender | ( | SceneManager * | sm,
|  | RenderSystem * | rsys
| ) |  |
| inlinevirtualinherited

Called immediately after the Renderable has been rendered.

## ◆ preRender()

virtual bool Ogre::Renderable::preRender | ( | SceneManager * | sm,
|  | RenderSystem * | rsys
| ) |  |
| inlinevirtualinherited

Called just prior to the Renderable being rendered.

Remarks
  OGRE is a queued renderer, so the actual render commands are executed at a later time than the point at which an object is discovered to be visible. This allows ordering & grouping of renders without the discovery process having to be aware of it. It also means OGRE uses declarative render information rather than immediate mode rendering - this is very useful in that certain effects and processes can automatically be applied to a wide range of scenes, but the downside is that special cases are more difficult to handle, because there is not the declared state to cope with it.

  This method allows a Renderable to do something special at the actual point of rendering if it wishes to. When this method is called, all the material render state as declared by this Renderable has already been set, all that is left to do is to bind the buffers and perform the render. The Renderable may modify render state itself if it wants to (and restore it in the postRender call) before the automated render happens, or by returning 'false' from this method can actually suppress the automatic render and perform one of its own.

Returns
  true if the automatic render should proceed, false to skip it on the assumption that the Renderable has done it manually.

Reimplemented in Ogre::v1::BillboardChain.

## ◆ removeCustomParameter()

void Ogre::Renderable::removeCustomParameter | ( | size_t | index | ) |
| inlineinherited

Removes a custom value which is associated with this Renderable at the given index.

Parameters

  index | Index of the parameter to remove.

See also
  setCustomParameter for full details.

## ◆ setAlignment()

void Ogre::v1::TextAreaOverlayElement::setAlignment | ( | Alignment | a | ) |
| inline

## ◆ setCaption()

virtual void Ogre::v1::TextAreaOverlayElement::setCaption | ( | const DisplayString & | text | ) |
| virtual

Sets the caption on elements that support it.

Remarks
  This property doesn't do something on all elements, just those that support it. However, being a common requirement it is in the top-level interface to avoid having to set it via the StringInterface all the time.

Reimplemented from Ogre::v1::OverlayElement.

## ◆ setCharHeight()

void Ogre::v1::TextAreaOverlayElement::setCharHeight | ( | Real | height | ) |

## ◆ setCloneable()

virtual void Ogre::v1::OverlayElement::setCloneable | ( | bool | c | ) |
| inlinevirtualinherited

## ◆ setColour()

void Ogre::v1::TextAreaOverlayElement::setColour | ( | const ColourValue & | col | ) |
| virtual

Sets the colour of the text.

Remarks
  This method establishes a constant colour for the entire text. Also see setColourBottom and setColourTop which allow you to set a colour gradient.

Reimplemented from Ogre::v1::OverlayElement.

## ◆ setColourBottom()

void Ogre::v1::TextAreaOverlayElement::setColourBottom | ( | const ColourValue & | col | ) |

Sets the colour of the bottom of the letters.

Remarks
  By setting a separate top and bottom colour, you can create a text area which has a graduated colour effect to it.

## ◆ setColourTop()

void Ogre::v1::TextAreaOverlayElement::setColourTop | ( | const ColourValue & | col | ) |

Sets the colour of the top of the letters.

Remarks
  By setting a separate top and bottom colour, you can create a text area which has a graduated colour effect to it.

## ◆ setCustomParameter()

void Ogre::Renderable::setCustomParameter | ( | size_t | index,
|  | const Vector4 & | value
| ) |  |
| inlineinherited

Sets a custom parameter for this Renderable, which may be used to drive calculations for this specific Renderable, like GPU program parameters.

Remarks
  Calling this method simply associates a numeric index with a 4-dimensional value for this specific Renderable. This is most useful if the material which this Renderable uses a vertex or fragment program, and has an ACT_CUSTOM parameter entry. This parameter entry can refer to the index you specify as part of this call, thereby mapping a custom parameter for this renderable to a program parameter.

Parameters

  index | The index with which to associate the value. Note that this does not have to start at 0, and can include gaps. It also has no direct correlation with a GPU program parameter index - the mapping between the two is performed by the ACT_CUSTOM entry, if that is used.
  value | The value to associate.

## ◆ setDatablock() [1/2]

virtual void Ogre::Renderable::setDatablock | ( | HlmsDatablock * | datablock | ) |
| virtualinherited

Assigns a datablock (i.e. HLMS Material) to this renderable.

Reimplemented in Ogre::v1::SubEntity, and Ogre::v1::BillboardSet.

## ◆ setDatablock() [2/2]

void Ogre::Renderable::setDatablock | ( | IdString | datablockName | ) |
| inherited

Assigns a datablock (i.e.

HLMS material) based on its unique name.

Remarks
  An null IdString() is valid, it will use the default material

## ◆ setDatablockOrMaterialName()

void Ogre::Renderable::setDatablockOrMaterialName | ( | String | materialName,
|  | String | groupName
| ) |  |
| inherited

First tries to see if an HLMS datablock exist with the given name, if not, tries to search among low level materials.

## ◆ setDimensions()

void Ogre::v1::OverlayElement::setDimensions | ( | Real | width,
|  | Real | height
| ) |  |
| inherited

Sets the dimensions of this element in relation to the screen (1.0 = screen width/height).

## ◆ setEnabled()

virtual void Ogre::v1::OverlayElement::setEnabled | ( | bool | b | ) |
| virtualinherited

## ◆ setFontName()

void Ogre::v1::TextAreaOverlayElement::setFontName | ( | const String & | font | ) |

## ◆ setHeight()

void Ogre::v1::OverlayElement::setHeight | ( | Real | height | ) |
| inherited

Sets the height of this element in relation to the screen (where 1.0 = screen height)

## ◆ setHorizontalAlignment()

virtual void Ogre::v1::OverlayElement::setHorizontalAlignment | ( | GuiHorizontalAlignment | gha | ) |
| virtualinherited

Sets the horizontal origin for this element.

Remarks
  By default, the horizontal origin for a OverlayElement is the left edge of the parent container (or the screen if this is a root element). You can alter this by calling this method, which is especially useful when you want to use pixel-based metrics (see setMetricsMode) since in this mode you can't use relative positioning.

  For example, if you were using GMM_PIXELS metrics mode, and you wanted to place a 30x30 pixel crosshair in the center of the screen, you would use GHA_CENTER with a 'left' property of -15.

  Note that neither GHA_CENTER or GHA_RIGHT alter the position of the element based on it's width, you have to alter the 'left' to a negative number to do that; all this does is establish the origin. This is because this way you can align multiple things in the center and right with different 'left' offsets for maximum flexibility.

## ◆ setLeft()

void Ogre::v1::OverlayElement::setLeft | ( | Real | left | ) |
| inherited

Sets the left of this element in relation to the screen (where 0 = far left, 1.0 = far right)

## ◆ setMaterial()

virtual void Ogre::Renderable::setMaterial | ( | const MaterialPtr & | material | ) |
| virtualinherited

Sets the given material. Overrides HLMS materials.

Reimplemented in Ogre::v1::SubEntity, Ogre::v1::BillboardSet, and Ogre::v1::SimpleRenderable.

## ◆ setMaterialName() [1/2]

void Ogre::v1::TextAreaOverlayElement::setMaterialName | ( | const String & | matName | ) |
| virtual

Overridden from OverlayElement.

Reimplemented from Ogre::v1::OverlayElement.

## ◆ setMaterialName() [2/2]

void Ogre::Renderable::setMaterialName | ( | const String & | name,
|  | const String & | groupName
| ) |  |
| inherited

Sets the name of the Material to be used. Prefer using HLMS @See setHlms.

## ◆ setMetricsMode()

void Ogre::v1::TextAreaOverlayElement::setMetricsMode | ( | GuiMetricsMode | gmm | ) |
| virtual

Overridden from OverlayElement.

Reimplemented from Ogre::v1::OverlayElement.

## ◆ setParameter()

virtual bool Ogre::StringInterface::setParameter | ( | const String & | name,
|  | const String & | value
| ) |  |
| virtualinherited

Generic parameter setting method.

Remarks
  Call this method with the name of a parameter and a string version of the value to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters.

Parameters

  name | The name of the parameter to set
  value | String value. Must be in the right format for the type specified in the parameter definition. See the StringConverter class for more information.

Returns
  true if set was successful, false otherwise (NB no exceptions thrown - tolerant method)

Referenced by Ogre::StringInterface::copyParametersTo().

## ◆ setParameterList()

virtual void Ogre::StringInterface::setParameterList | ( | const NameValuePairList & | paramList | ) |
| virtualinherited

Generic multiple parameter setting method.

Remarks
  Call this method with a list of name / value pairs to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters.

Parameters

  paramList | Name/value pair list

## ◆ setPolygonModeOverrideable()

virtual void Ogre::Renderable::setPolygonModeOverrideable | ( | bool | override | ) |
| inlinevirtualinherited

Sets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.

Parameters

  override | true means that a lower camera detail will override this renderables detail level, false means it won't.

## ◆ setPoseWeight()

void Ogre::Renderable::setPoseWeight | ( | size_t | index,
|  | float | w
| ) |  |
| inherited

## ◆ setPosition()

void Ogre::v1::OverlayElement::setPosition | ( | Real | left,
|  | Real | top
| ) |  |
| inherited

Sets the position of the top-left corner of the element, relative to the screen size (1.0 = screen width / height)

## ◆ setRenderQueueSubGroup()

void Ogre::Renderable::setRenderQueueSubGroup | ( | uint8 | subGroup | ) |
| inlineinherited

Sets the render queue sub group.

Remarks
  Within the same RenderQueue ID, you may want to have the renderables to have a specific order (i.e. have a mesh, but the hair submesh with alpha blending needs to be rendered last).

  RenderQueue Subgroups are useful for manually sorting objects, just like RenderQueue IDs. However, RenderQueue IDs can also be useful for skipping large number of objects through clever compositing and thus a performance optimization. Subgroups cannot be used for such optimizations.

Parameters

  subGroup | The sub group. This value can't exceed OGRE_MAKE_MASK( SubRqIdBits ) @See RenderQueue

## ◆ setSpaceWidth()

void Ogre::v1::TextAreaOverlayElement::setSpaceWidth | ( | Real | width | ) |

## ◆ setTop()

void Ogre::v1::OverlayElement::setTop | ( | Real | Top | ) |
| inherited

Sets the top of this element in relation to the screen (where 0 = top, 1.0 = bottom)

## ◆ setUseIdentityProjection()

void Ogre::Renderable::setUseIdentityProjection | ( | bool | useIdentityProjection | ) |
| inlineinherited

Sets whether or not to use an 'identity' projection.

Remarks
  Usually Renderable objects will use a projection matrix as determined by the active camera. However, if they want they can cancel this out and use an identity projection, which effectively projects in 2D using a {-1, 1} view space. Useful for overlay rendering. Normal renderables need not change this. The default is false.

See also
  Renderable::getUseIdentityProjection

## ◆ setUseIdentityView()

void Ogre::Renderable::setUseIdentityView | ( | bool | useIdentityView | ) |
| inlineinherited

Sets whether or not to use an 'identity' view.

Remarks
  Usually Renderable objects will use a view matrix as determined by the active camera. However, if they want they can cancel this out and use an identity matrix, which means all geometry is assumed to be relative to camera space already. Useful for overlay rendering. Normal renderables need not change this. The default is false.

See also
  Renderable::getUseIdentityView

## ◆ setUserAny()

virtual OGRE_DEPRECATED void Ogre::Renderable::setUserAny | ( | const Any & | anything | ) |
| inlinevirtualinherited

Deprecated:
  use UserObjectBindings::setUserAny via getUserObjectBindings() instead. Sets any kind of user value on this object.

Remarks
  This method allows you to associate any user value you like with this Renderable. This can be a pointer back to one of your own classes for instance.

## ◆ setVerticalAlignment()

virtual void Ogre::v1::OverlayElement::setVerticalAlignment | ( | GuiVerticalAlignment | gva | ) |
| virtualinherited

Sets the vertical origin for this element.

Remarks
  By default, the vertical origin for a OverlayElement is the top edge of the parent container (or the screen if this is a root element). You can alter this by calling this method, which is especially useful when you want to use pixel-based metrics (see setMetricsMode) since in this mode you can't use relative positioning.

  For example, if you were using GMM_PIXELS metrics mode, and you wanted to place a 30x30 pixel crosshair in the center of the screen, you would use GHA_CENTER with a 'top' property of -15.

  Note that neither GVA_CENTER or GVA_BOTTOM alter the position of the element based on it's height, you have to alter the 'top' to a negative number to do that; all this does is establish the origin. This is because this way you can align multiple things in the center and bottom with different 'top' offsets for maximum flexibility.

## ◆ setWidth()

void Ogre::v1::OverlayElement::setWidth | ( | Real | width | ) |
| inherited

Sets the width of this element in relation to the screen (where 1.0 = screen width)

## ◆ show()

virtual void Ogre::v1::OverlayElement::show | ( | void |  | ) |
| virtualinherited

Shows this element if it was hidden.

## Member Data Documentation

## ◆ mCustomParameter

uint8 Ogre::Renderable::mCustomParameter
| inherited

Only valid when using low level materials.

## ◆ mHlmsGlobalIndex

uint32 Ogre::Renderable::mHlmsGlobalIndex
| inherited

Index in the vector holding this Rendrable reference in the HLMS datablock.

Used for O(1) removals.

Remarks
  Despite being public, Do NOT modify it manually.

The documentation for this class was generated from the following file:

- OgreTextAreaOverlayElement.h